/******************************************************************************
 *
 *                Copyright (c) 2017-2019 by Löwenware Ltd
 *             Please, refer LICENSE file for legal information
 *
 ******************************************************************************/

/**
 * @file template.h
 * @author Ilja Kartašov <ik@lowenware.com>
 * @brief 
 *
 * @see https://lowenware.com/
 */

#ifndef AX_HTML_H_92C08532_E423_4CE4_A44C_27CF864A2C60
#define AX_HTML_H_92C08532_E423_4CE4_A44C_27CF864A2C60

#include <stdint.h>
#include <stdbool.h>
#include <aisl/aisl.h>
#include <cStuff/list.h>

#define AX_HTML_NULL  0
#define AX_HTML_PLAIN 1
#define AX_HTML_BLOCK 2
#define AX_HTML_INPUT 3

struct ax_html {
	uint16_t type;
	uint16_t offset;
	uint32_t size;
	char *data;
};

struct ax_html_options {
	const char *offset;
	const char *path;
	const char *name;
	bool minimize;
};


AislStatus
ax_html_import(CStuffList list, const char *html_file);


AislStatus
ax_html_export(CStuffList list, const struct ax_html_options *opts);


void
ax_html_free(struct ax_html *html);


#endif /* !HTML_H */
