/******************************************************************************
 *
 *                Copyright (c) 2017-2019 by Löwenware Ltd
 *             Please, refer LICENSE file for legal information
 *
 ******************************************************************************/

/**
 * @file mod-feedback.h
 * @author Ilja Kartašov <ik@lowenware.com>
 * @brief AISL ToDo.txt module header file
 *
 * @see https://lowenware.com/aisl/
 */

#ifndef MINION_H2FC5C912_0F59_43AD_B805_B0F7C82BE2EF
#define MINION_H2FC5C912_0F59_43AD_B805_B0F7C82BE2EF

#include <cStuff/list.h>
#include <mods/context.h>
#include <mods/module.h>
#include <components/todo.h>

/* ToDo:
 * Start with one todo.txt file
 * Write ToDo.txt parser
 * Join them together
 */

struct ax_minion_cfg {
	const char *end_point;
	const char *todo_file;
};


struct ax_minion {
	struct ax_module root;
	struct ax_todo todo;
	struct cstuff_list tasks;
	struct cstuff_list projects;
	struct cstuff_list tags;
};


typedef struct ax_minion *AxMinion;


AislStatus
ax_minion_init(AxMinion mod, const struct ax_minion_cfg *cfg);


void
ax_minion_release(AxMinion mod);

#endif /* !MINION_H */
